#!/usr/bin/perl
use utf8;
use Encode qw(decode encode decode_utf8 is_utf8);
use CGI qw(:standard);
use JSON::PP;
use File::Slurp;
use Data::Dumper;
use MIME::Base64;
use Digest::MD5 qw(md5 md5_hex md5_base64);
no warnings 'utf8';
#use open qw/ :std :encoding(utf8) /; ### This breaks binary file uploads (utf-8 issue on STDIN).
#print "Content-type: text/html; charset=utf-8\n\n"; #debug

$CGI::POST_MAX = 1024 * 15000;
$BASE			= "/home/fabmicro/SIPHomePhone/web_admin_docroot/";
$DICT      		= "$BASE/tpl/dicts";
$TEMPLATES 		= "$BASE/tpl";
$DEFAULT_LANGUAGE	= "russian";
$left_tag='<\?'; 
$right_tag='\?>';
#if( ! defined($language) ) {$language = $DEFAULT_LANGUAGE;}
#$dict_file     = $DICT."/$language.dict";
#require "$dict_file";
#$template_file = $TEMPLATES."/$tpl";
#-f $template_file or die "File $template_file not exists";
#include_ $template_file;
#require ($BASE."admin_tpl.pl");


$prog = "admin_new.cgi";
$jsoneditor_html = "web_admin_docroot/jsoneditor.html";
$newjsoneditor_html = "web_admin_docroot/newjsoneditor.html";
$network_interfaces_template_file = "./interfaces.template";
$network_interfaces_file = "/var/lib/interfaces";
$evdevname = "/home/fabmicro/SIPHomePhone/evdevname";
$sunbus_version_file = "/tmp/sunbus.version.log";

$query_uri = $ENV{'REQUEST_URI'};

$query = new CGI;
$action = $query->param("action");


if(-f $ENV{X_MANAGED_CONFIG} ) {
	$current_config_text = read_file($ENV{X_MANAGED_CONFIG}, {binmode => ':utf8'});
	#$current_config_text = read_file($ENV{X_MANAGED_CONFIG});
} elsif(-f $ENV{X_DEFAULT_CONFIG}) {
	$current_config_text = read_file($ENV{X_DEFAULT_CONFIG}, {binmode => ':utf8'});
	#$current_config_text = read_file($ENV{X_DEFAULT_CONFIG});
} elsif(-f "all.json.default") {
	$current_config_text = read_file("all.json.default", {binmode => ':utf8'});
	#$current_config_text = read_file("all.json.default");
} else {
	print "Content-type: text/html; charset=utf-8\n\n";
	print "Cannot find JSON config!\n";
	exit(3);
}

$enable = true;
$json_parser = JSON::PP->new;
$json_parser = $json_parser->relaxed($enable);
$json_parser = $json_parser->pretty($enable);
$json_parser = $json_parser->allow_barekey($enable);
$json_parser = $json_parser->canonical($enable);
#eval { $current_config_json  = $json_parser->utf8->decode($current_config_text); };
eval { $current_config_json  = $json_parser->decode($current_config_text); };

$loaded_config_serial = $current_config_json->{Config}->{serial};
$loaded_config_source = $current_config_json->{Config}->{source};

$EDITABLE_SECTIONS = {
	LockManager => {
		descr => 'Управление замками',
		type => 'editable',
		schema => 'web_admin_docroot/schema/lock_manager.json.schema',
	},
	HandsetState => {
		descr => 'Датчик аналоговой трубки',
		type => 'editable',
		schema => 'web_admin_docroot/schema/handset_state.json.schema',
	},	
	ProximitySensor => {
		descr => 'Датчик присутствия',
		type => 'editable',
		schema => 'web_admin_docroot/schema/proximity_sensor.json.schema',
	},
	AmbientSensor => {
		descr => 'Датчик освещенности',
		type => 'editable',
		schema => 'web_admin_docroot/schema/ambient_sensor.json.schema',
	},
	RS485Master => {
		descr => 'Мастер RS485 интерфейса',
		type => 'editable',
		schema => 'web_admin_docroot/schema/rs485_master.json.schema',
	},
	RFIDReader => {
		descr => 'Считыватель RFID меток',
		type => 'editable',
		schema => 'web_admin_docroot/schema/rfid_reader.json.schema',
	},
	DoorsAndButtons => {
		descr => 'Датчики положения дверей и кнопки',
		type => 'editable',
		schema => 'web_admin_docroot/schema/doors_and_buttons.json.schema',
	},
	Notify => {
		descr => 'Оповещения о событиях',
		type => 'editable',
		schema => 'web_admin_docroot/schema/notify.json.schema',
	},
	Common => {
		descr => 'Настройки общие для разных модулей',
		type => 'editable',
		schema => 'web_admin_docroot/schema/common.json.schema',
	},
	Apartments => {
		descr => 'Помещения, RFID ключи и маршруты звонков',
		type => 'editable',
		schema => 'web_admin_docroot/schema/apartments.json.schema',
	},
	Yard => {
		descr => 'Двор',
		type => 'editable',
		schema => 'web_admin_docroot/schema/yard.json.schema',
	},
	Advertizer => {
		descr => 'Рекламные слайды и обьявления',
		type => 'editable',
		schema => 'web_admin_docroot/schema/advertizer.json.schema',
	},
	GUI => {
		descr => 'Графический интерфейс',
		type => 'editable',
		schema => 'web_admin_docroot/schema/gui.json.schema',
	},
};


if(length($action) < 1) {
	$action = $current_config_json->{WebAdmin}->{default_action};

	if(length($action) < 1) {
		$action = 'list_sections';
	}
}


if($action eq 'wizard') {
	($ip,$mask,$gateway,$mac)=ifconfig("eth0");
	print_tpl ("header");
	print_tpl ("wizard");
	print_tpl ("footer");
	exit(0);
}

if($action eq 'wizard_step2') {
	print_tpl ("header");
	print_tpl ("wizard_step2");
	print_tpl ("footer");
	exit(0);
}

if($action eq 'wizard_step3') {

	eval { $section_json_text  = $json_parser->utf8->encode($current_config_json->{Common}->{SipPatterns}); };
		
	$data_base64 = encode_base64($section_json_text);
	$data_base64 =~ s/\n/\"+\n\"/g;
	
	my $tmp_schema=read_file($EDITABLE_SECTIONS->{Common}->{schema});
	my $tmp_schema_json=$json_parser->utf8->decode($tmp_schema);

	$schema_base64 = encode_base64($json_parser->utf8->encode($tmp_schema_json->{properties}->{SipPatterns}));
	$schema_base64 =~ s/\n/\"+\n\"/g;

	$html = read_file($newjsoneditor_html, {binmode => ':utf8'});

	$html =~ s/__SECTION_ID__/$section/g;
	$html =~ s/__SECTION_NAME__/$EDITABLE_SECTIONS->{$section}->{descr}/g;
	$html =~ s/__DATA__/$data_base64/g;
	$html =~ s/__SCHEMA__/$schema_base64/g;

	print_tpl ("header");
	print_tpl ("wizard_step3");
	print_tpl ("footer");
	exit(0);
}

if($action eq 'wizard_step4') {
	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}



if($action eq 'wizard_reboot') {
	print_tpl ("header");
	print_tpl ("reboot");
	exit(0);
}

if($action eq 'wizard_step2final') {
	$config_url = $query->param("uri");
	$new_password = $query->param("pass");
	($ip,undef,undef,undef)=ifconfig("eth0");

	$current_config_json->{Config}->{config_url} = $config_url;
	$current_config_json->{WebAdmin}->{default_action} = "list_sections";

	save_config();
	$new_password .= "\n";
	$config_password_file = $ENV{X_CONFIG_SPOOL_DIR} . "/" . $current_config_json->{Configurator}->{password_file_name}; 
	write_file($config_password_file, $new_password);

	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}





#		$current_config_json->{WebAdmin}->{web_password} = $new_password;
#		save_config();



sub ifconfig {
	my $if=shift;
	my ($ip,$mask,$gateway,$mac)=("0.0.0.0","0.0.0.0","0.0.0.0",undef);
	#$ifconfig;
	open(IFCONFIG, "/sbin/ifconfig $if|");
	while(<IFCONFIG>) { if (/[inet|ether]/) { $ifconfig.=$_." "; }}
	close(IFCONFIG);

	($ip) = $ifconfig =~/.*inet ([0-9]+\.[0-9]+.[0-9]+.[0-9]+) .*/;
	($mask) = $ifconfig =~ /.*netmask ([0-9]+\.[0-9]+.[0-9]+.[0-9]+) .*/;
	($mac) = $ifconfig =~ /.*ether ([0-9A-Fa-f]{0,2}(:[0-9A-Fa-f]{2}){0,5}:?).*/;  #c6:96:58:f4:aa:c9

	open(NETSTAT, "/bin/netstat -rn|");
	while(<NETSTAT>) { if (/^0.0.0.0/) { ($_, $gateway, @_) = split(' ', $_); last; }}

	return ($ip,$mask,$gateway,$mac);
}


if($action eq 'list_sections') {
	print_tpl ("header");
	print_tpl ("list_sections");
	print_tpl ("footer");
	exit(0);
}


if($action eq 'edit_section') {

	$section = $query->param("section");

	print_tpl ("header");

	if(($EDITABLE_SECTIONS->{$section}->{type} eq 'editable')) {
		#print "Конфигурационный раздел: ".$EDITABLE_SECTIONS->{$section}->{descr}."\n";
		#print "<h3>Конфигурационный раздел:</h3>\n";
		print "<hr>\n";

		if(! exists($current_config_json->{$section})) { $current_config_json->{$section} = (); }

		if(exists ($current_config_json->{$section})  && -f $EDITABLE_SECTIONS->{$section}->{schema}) {
			eval { $section_json_text  = $json_parser->utf8->encode($current_config_json->{$section}); };
			#eval { $section_json_text  = $json_parser->encode($current_config_json->{$section}); };
		
			$data_base64 = encode_base64($section_json_text);
			$data_base64 =~ s/\n/\"+\n\"/g;
			
			#$schema_base64 = encode_base64(read_file($EDITABLE_SECTIONS->{$section}->{schema}, {binmode => ':utf8'}));
			$schema_base64 = encode_base64(read_file($EDITABLE_SECTIONS->{$section}->{schema}));
			$schema_base64 =~ s/\n/\"+\n\"/g;

			$html = read_file($newjsoneditor_html, {binmode => ':utf8'});

			$html =~ s/__SECTION_ID__/$section/g;
			$html =~ s/__SECTION_NAME__/$EDITABLE_SECTIONS->{$section}->{descr}/g;
			$html =~ s/__DATA__/$data_base64/g;
			$html =~ s/__SCHEMA__/$schema_base64/g;

			print $html;

		} else {
			print "Отсутствует JSON схема для данного раздела.\n";
		}
	} else { 
		print "<h3>Конфигурационный раздел: ".$EDITABLE_SECTIONS->{$section}->{descr}."</h3>\n";
		print "<hr>\n";
		if(exists ($current_config_json->{$section}) ) {
			print "<PRE>\n";
			eval { $section_json_text  = "\"".$section."\" : ".$json_parser->utf8->encode($current_config_json->{$section}); };
			print "$section_json_text\n";
			print "</PRE>\n";
		} else {
			print "В данный момент раздел отсутствует\n";
		}
	}


	print_tpl ("footer");
	exit(0);
}


if($action eq 'newedit_sippatterns') {

	print_tpl ("header");
	print "<h3>Конфигурационный раздел:</h3>\n";
	print "<hr>\n";

	eval { $section_json_text  = $json_parser->utf8->encode($current_config_json->{Common}->{SipPatterns}); };
		
	$data_base64 = encode_base64($section_json_text);
	$data_base64 =~ s/\n/\"+\n\"/g;
	
	my $tmp_schema=read_file($EDITABLE_SECTIONS->{Common}->{schema});
	my $tmp_schema_json=$json_parser->utf8->decode($tmp_schema);

	$schema_base64 = encode_base64($json_parser->utf8->encode($tmp_schema_json->{properties}->{SipPatterns}));
	$schema_base64 =~ s/\n/\"+\n\"/g;

	$html = read_file($jsoneditor_html, {binmode => ':utf8'});

	$html =~ s/__SECTION_ID__/$section/g;
	$html =~ s/__SECTION_NAME__/$EDITABLE_SECTIONS->{$section}->{descr}/g;
	$html =~ s/__DATA__/$data_base64/g;
	$html =~ s/__SCHEMA__/$schema_base64/g;

	print $html;
#		use Data::Dumper;
#		print Dumper ($section_json_text);
#		print "<br><br>";
#		print Dumper($tmp_schema_json);

	print_tpl ("footer");
	exit(0);
}



if($action eq 'system_settings') {
	print_tpl("header");
	print_tpl($action);
	print_tpl("footer");
	exit(0);
}



if($action eq 'network_settings') {
	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'network_change_web_credentials') {
	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'network_change_web_credentials_submit') {

	$old_username = $query->param("old_username");
	$old_password = $query->param("old_password");
	$new_username = $query->param("new_username");
	$new_password = $query->param("new_password");

	print_tpl ("header");

	print "Изменить имя пользователя и пароль для Web интерфейса:\n";
	print "<HR>\n";

	if($old_username eq $current_config_json->{WebAdmin}->{web_admin} &&
	   $old_password eq $current_config_json->{WebAdmin}->{web_password} ) {

		$current_config_json->{WebAdmin}->{web_admin} = $new_username;
		$current_config_json->{WebAdmin}->{web_password} = $new_password;

		save_config();

		print "Изменения сохранены и примут силу после <a href='\$restart\$'>перезапуска всех модулей</a> или <a href='\$reboot\$'>перезагрузки системы</a>.\n";
	} else {
		print "Текущие имя пользователя или пароль не совпадают!\n";
	}

	print_tpl ("footer");
	exit(0);
}


if($action eq 'network_change_config_credentials') {
	print_tpl ("header");
	print_tpl ("$action");
	print_tpl ("footer");
	exit(0);
}



if($action eq 'network_change_config_credentials_submit') {
	$config_url = $query->param("config_url");
	$new_password = $query->param("new_password");
	$current_config_json->{Config}->{config_url} = $config_url;
	save_config();
	$new_password .= "\n";
	$config_password_file = $ENV{X_CONFIG_SPOOL_DIR} . "/" . $current_config_json->{Configurator}->{password_file_name}; 
	write_file($config_password_file, $new_password);

	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'network_change_network_interfaces') {
#	open(IFCONFIG, "/sbin/ifconfig eth0|");
#	while(<IFCONFIG>) { if (/ inet /) { $ifconfig = $_; last; }}
#	close(IFCONFIG);
#	$IP = $ifconfig; $IP =~ s/.*inet ([0-9]+\.[0-9]+.[0-9]+.[0-9]+) .*/\1/g;
#	$MASK = $ifconfig; $MASK =~ s/.*netmask ([0-9]+\.[0-9]+.[0-9]+.[0-9]+) .*/\1/g;

	open(NETSTAT, "/bin/netstat -rn|");
	while(<NETSTAT>) { if (/^0.0.0.0/) { ($_, $GATEWAY, @_) = split(' ', $_); last; }}

	($IP,$MASK,undef,undef)=ifconfig("eth0");

	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'network_change_network_interfaces_submit') {

	$ip = $query->param("ip");
	$mask = $query->param("mask");
	$gateway = $query->param("gateway");
	$type = $query->param("type");
	$default_action = $query->param("default_action") || "";

	$ip =~ s/ //g;
	$mask =~ s/ //g;
	$gateway =~ s/ //g;
	my $result_code=0;

	print_tpl ("header");
	print_tpl ($action);
	if ($result_code==1) {
		$network_interfaces = read_file($network_interfaces_template_file);
		$network_interfaces =~ s/__TYPE__/$type/g;
		$network_interfaces =~ s/__IP__/$ip/g;
		$network_interfaces =~ s/__MASK__/$mask/g;
		$network_interfaces =~ s/__GATEWAY__/$gateway/g;
		write_file($network_interfaces_file, $network_interfaces);
	}

	if ($default_action eq "wizard_step2") {
		$current_config_json->{WebAdmin}->{default_action} = "wizard_step2";
		save_config();
		print_tpl ("wizard_reboot");
	}

	print_tpl ("footer");
	exit(0);

}

if($action eq 'system_download_all_json') {
	print_tpl ("all_json_header");
	print $current_config_text."\n";
	exit(0);
}

if($action eq 'system_upload_all_json') {
	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_upload_all_json_submit') {
	$file_handle = $query->upload("file");
	binmode($file_handle, ":utf8");
	$loaded_config_text;
	while(<$file_handle>) {	$loaded_config_text .= $_;}
	$current_config_text = $loaded_config_text;
	save_config();

	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}



if($action eq 'system_view_all_json') {
	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_view_request_params') {
	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_view_config_spool_dir') {

	print_tpl ("header");
	print_tpl ("$action");	
	print_tpl ("footer");
	exit(0);
}

if($action eq 'system_view_media_spool_dir') {
	my $media_dir = $current_config_json->{HTTPRequester}->{media_dir};
	print_tpl ("header");
	print_tpl ("$action");	
	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_view_spool_file') {

	$name = $query->param("name");
	$name =~ s/\.\.\///g;

	$file = $ENV{X_CONFIG_SPOOL_DIR}."/".$name;

	print_tpl ("header");

	print "Просмотр файла в конфигурационном спуле: $name\n";
	print "<HR>\n";
	print "<PRE>\n";

	if(-f $file) {
		$text = read_file($file , {binmode => ':utf8'});
		print "$text\n";
	} else {
		print "<script>alert(\"Файл $name не найден!\");self.location=\"$prog?action=system_view_config_spool_dir\";</script>\n";
	}

	print "</PRE>\n";

	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_download_spool_file') {

	$name = $query->param("name");
	$name =~ s/\.\.\///g;

	$file = $ENV{X_CONFIG_SPOOL_DIR}."/".$name;

	if(-f $file) {
		print "Content-type: application/json\n\n";
		$text = read_file($file , {binmode => ':utf8'});
		print "$text\n";
	} else {
		print_tpl ("header");
		print "<script>alert(\"Файл $name не найден!\");self.location=\"$prog?action=system_view_config_spool_dir\";</script>\n";
		print_tpl ("footer");
	}


	exit(0);
}


if($action eq 'system_view_media_spool_file') {

	$name = $query->param("name");
	$name =~ s/\.\.\///g;
	$file = $current_config_json->{HTTPRequester}->{media_dir}."/".$name;

	print_tpl ("header");

	print "Просмотр файла медиа спуле: $name\n";
	print "<HR>\n";
	print "<PRE>\n";

	if(-f $file) {
		$text = read_file($file , {binmode => ':utf8'});
		print "$text\n";
	} else {
		print "<script>alert(\"Файл $name не найден!\");self.location=\"$prog?action=system_view_media_spool_dir\";</script>\n";
	}

	print "</PRE>\n";

	print_tpl ("footer");
	exit(0);
}





if($action eq 'system_delete_spool_file') {

	$name = $query->param("name");
	$name =~ s/\.\.\///g;

	$file = $ENV{X_CONFIG_SPOOL_DIR}."/".$name;

	print_tpl ("header");
	

	if(-f $file) {
		unlink $file;
		print "<script>alert(\"Файл $name удален!\");self.location=\"$prog?action=system_view_config_spool_dir\";</script>\n";
	} else {                                            
		print "<script>alert(\"Файл $name не найден!\");self.location=\"$prog?action=system_view_config_spool_dir\";</script>\n";
	}

	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_delete_media_spool_file') {

	$name = $query->param("name");
	$name =~ s/\.\.\///g;

	$file = $current_config_json->{HTTPRequester}->{media_dir}."/".$name;

	print_tpl ("header");
	

	if(-f $file) {
		unlink $file;
		print "<script>alert(\"Файл $name удален!\");self.location=\"$prog?action=system_view_media_spool_dir\";</script>\n";
	} else {
		print "<script>alert(\"Файл $name не найден!\");self.location=\"$prog?action=system_view_media_spool_dir\";</script>\n";
	}

	print_tpl ("footer");
	exit(0);
}



if($action eq 'system_view_dhcp_lease') {

	print_tpl ("header");

	if(exists ($current_config_json->{Configurator}) && -f $current_config_json->{Configurator}->{dhcp_lease_file} ) {
		$dhcp_lease_text = read_file($current_config_json->{Configurator}->{dhcp_lease_file});
	} else {
		$dhcp_lease_text="";
	}
	print_tpl ("$action");

	print_tpl ("footer");
	exit(0);
}



if($action eq 'system_view_network_interfaces') {

	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_device_diagnostics') {

	$| = 1;
	use IO::Select;

	print_tpl ("header");
	my $pid = open($fd, "/etc/diag.pl|");
	$body="";
	while(<$fd>) {
		$msg = $_;
		chop($msg);
		$msg =~ s/\[1;31m/<span style="color:red">/g;
		$msg =~ s/\[1;32m/<span style="color:green">/g;
		$msg =~ s/\[0m/<\/span>/g;
		$body.=$msg."\r\n";
	}
	close($fd);
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}




if($action eq 'save_section') {

	$section = $query->param("section");
	$content = $query->param("content");
	$subsection = $query->param("subsection") || "";
	$next_action = $query->param("next_action") || "";


	$content = decode('UTF-8',decode_base64($content));
	#$section_json = $json_parser->utf8->decode($content);
	#$section_text = $json_parser->utf8->encode($section_json);
	$section_json = $json_parser->decode($content);
	#$section_text = $json_parser->utf8->encode($section_json);
	$section_text = $json_parser->encode($section_json);


	print_tpl ("header");

	if(($EDITABLE_SECTIONS->{$section}->{type} eq 'editable')) {
		print "Конфигурационный раздел: $section - ".$EDITABLE_SECTIONS->{$section}->{descr}."\n";
		print "<HR>\n";
		print "Получены и сохранены следующие данные:<BR><BR>\n\n";
		print "<PRE>\"$section\" : $section_text\n</PRE>";

		if ($subsection eq "") {
			$current_config_json->{$section} = $section_json;
		} elsif ($subsection ne "") {
			$current_config_json->{$section}->{$subsection} = $section_json;
		}

		if ($next_action ne "") {
			$current_config_json->{WebAdmin}->{default_action} = $next_action;
			print "<div class=\"form-group\"><a href=\"$prog?action=$next_action\"><button class=\"btn btn-primary\">Далее</button></a></div>";
		}

		if(save_config()) {
			print "<script>if(confirm('Перезагрузить модули ?')){self.location='/restart.cgi';}</script>\n";
		} else {
			print "<PRE>\n";
			print "Возникла ошибка при сохранении конфигурационного файла!\n";
			print "1. Проверте наличие свободного пространства на накопителе в разделе <b>/var</b>\n";
			print "2. Удалите невостребованные конфигурационные файлы в <a href='$prog?action=system_view_config_spool_dir'>конфигурационном спуле</a>.\n";
			print "3. Удалите невостребованные медиа файлы в <a href='$prog?action=system_view_media_spool_dir'>медиа-спуле</a>.\n";
			print "</PRE>\n";
		}

	} else { 
		print "Конфигурационный раздел: ".$EDITABLE_SECTIONS->{$section}->{descr}." ($section) - ИЗМЕНЕНИЮ НЕ ПОДЛЕЖИТ\n";
		print "<HR>\n";
		if(exists ($current_config_json->{$section}) ) {
			print "<PRE>\n";
			eval { $section_json_text  = "\"".$section."\" : ".$json_parser->utf8->encode($current_config_json->{$section}); };
			print "$section_json_text\n";
			print "</PRE>\n";
		} else {
			print "В данный момент раздел отсутствует\n";
		}
	}

	print_tpl ("footer");
	exit(0);
}


if($action eq 'sensors') {
	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}

if($action eq 'rfid_reader') {
	print_tpl ("header");
	print_tpl ("$action");
	print "<script>self.location='$prog?filter=MFRC522_READER.*card_present&action=system_view_monitor'</script>\n";
	exit(0);
}

if($action eq 'rfid_reader_old') {

	$| = 1;
	use IO::Select;

	print_tpl ("header");
	print_tpl ("$action");

	my $dev = $current_config_json->{RFIDReader}->{serial};

	if(length($dev) < 1) {
		$device=$dev;
		print_tpl ("device_not_found");		
		print_tpl ("footer");
		exit(0);
	}

	# printf(STDERR "Opening device: $dev\n");

	my $fd_event = \*EVENT;
	my $fd_stdin = \*STDIN;

	my $pid = open($fd_event, "/bin/cat ".$dev."|");
	#my $pid = open($fd_event, $dev);

	if(!$pid) {
		print_tpl ("device_not_reachable");
		print_tpl ("footer");
		exit(0);
	}

	$s = IO::Select->new();
	$s->add($fd_stdin);
	$s->add($fd_event);

	my $terminate = 0;

	my $lines = 0;

	print "<PRE>\n";

	while($terminate == 0) {

		@fds = $s->has_exception(0);

		last if($fds > 0);

		@fds = $s->can_read(1);

		foreach my $fd (@fds) {
			if($fd == $fd_stdin) { $terminate = 1; next; }

			$line = <$fd>;
			chop($line);

			next if($line =~ /RAW DATA/);

			print time() . ": $line <script> window.scrollTo({ left: 0, top: document.body.scrollHeight, behavior: 'smooth' }); </script>\n";
			STDOUT->flush();
		}

		$lines++;
	}

	print "</PRE>\n";


	kill(9, $pid);
	close($fd_event);

	print_tpl ("footer");
	exit(0);
}


if($action eq 'proximity_sensor') {

	$| = 1;
	use IO::Select;
	$s = IO::Select->new();
	$s->add(\*STDIN);

	print_tpl ("header");
	print_tpl ($action);

	my $device_file = $current_config_json->{ProximitySensor}->{hwmon_device};

	if(length($device_file) < 1) {
		$device=$current_config_json->{ProximitySensor}->{hwmon_device};
		print_tpl ("device_not_found");
		print_tpl ("footer");
		exit(0);
	}

	while(1) {
		$! = 0;
		$ret = $s->can_read(.5);
		if($ret != 0) {
			last;
		}

		$range = read_file($device_file);
		chop($range);

		print time() . " - range: $range<BR>\n";
		print "<script> window.scrollTo({ left: 0, top: document.body.scrollHeight, behavior: 'smooth' }); </script>\n";
		STDOUT->flush();
	}

	print "BYE\n";

	print_tpl ("footer");
	exit(0);

}


if($action eq 'ambient_sensor') {

	$| = 1;
	use IO::Select;
	$s = IO::Select->new();
	$s->add(\*STDIN);

	print_tpl ("header");
	print_tpl ("$action");

        my $device_file = FindHwmonDevice($current_config_json->{AmbientSensor}->{hwmon_device_name});
        my $input = $current_config_json->{AmbientSensor}->{hwmon_input};

        if(length($device_file) < 1) {
                print "Файл не найден для устройства с именем '".$current_config_json->{AmbientSensor}->{hwmon_device_name}.
"', проверьте правильность ввода имени устройства в конфигурационном файле, а так же наличие устройств с таким именем в разделе <a href
=\"$prog?action=system_device_diagnostics\">Диагностика Устройств</a>\n";
                footer();
                exit(0);
        }

        $device_file =~ s/\/name/\/$input/g;

        while(1) {
                $! = 0;
                $ret = $s->can_read(.5);
                if($ret != 0) {
                        last;
                }

                $adc = read_file($device_file);
                chop($adc);

                print time() . ": $adc<BR>\n";
                print "<script> window.scrollTo({ left: 0, top: document.body.scrollHeight, behavior: 'smooth' }); </script>\n";
                STDOUT->flush();
        }


	print "BYE\n";

	print_tpl ("footer");
	exit(0);

}

if($action eq 'handset_state') {

	$| = 1;
	use IO::Select;
	$s = IO::Select->new();
	$s->add(\*STDIN);

	print_tpl ("header");
	print_tpl ($action);

        my $device_file = FindHwmonDevice($current_config_json->{HandsetState}->{hwmon_device_name});
        my $input = $current_config_json->{HandsetState}->{hwmon_input};

        if(length($device_file) < 1) {
                print "Файл не найден для устройства с именем '".$current_config_json->{HandsetState}->{hwmon_device_name}."
', проверьте правильность ввода имени устройства в конфигурационном файле, а так же наличие устройств с таким именем в разделе <a href=
\"$prog?action=system_device_diagnostics\">Диагностика Устройств</a>\n";
                footer();
                exit(0);
        }

        $device_file =~ s/\/name/\/$input/g;

        while(1) {
                $! = 0;
                $ret = $s->can_read(.5);
		if($ret != 0) {
			last;
		}

		$adc = read_file($device_file);
		chop($adc);

		print time() . ": $adc<BR>\n";
		print "<script> window.scrollTo({ left: 0, top: document.body.scrollHeight, behavior: 'smooth' }); </script>\n";
		STDOUT->flush();
	}

	print_tpl ("footer");
	exit(0);
}



if($action eq 'doors_and_buttons_sensors') {

	$| = 1;
	use IO::Select;

	print_tpl ("header");
	print_tpl ($action);

	my $dev = FindInputDevice($current_config_json->{DoorsAndButtons}->{input_device_name});

	if(length($dev) < 1) {
		$device=$current_config_json->{DoorsAndButtons}->{input_device_name};
		print_tpl ("device_not_found");
		print_tpl ("footer");
		exit(0);
	}

	printf(STDERR "Opening device: $dev\n");

	my $fd_event = \*EVENT;
	my $fd_stdin = \*STDIN;

	my $pid = open($fd_event, "/usr/bin/evtest ".$dev."|");

	$s = IO::Select->new();
	$s->add($fd_stdin);
	$s->add($fd_event);

	my $terminate = 0;

	print "<PRE>\n";

	while($terminate == 0) {

		@fds = $s->can_read(1);

		foreach my $fd (@fds) {
			if($fd == $fd_stdin) { $terminate = 1; next; }

			$msg = <$fd>;
			chop($msg);

			if($msg =~ /EV_KEY/) {
				$msg =~ s/code ([0-9]*)/code <font color=red><B>\1<\/B><\/font>/g;
			}

			print time() . ": $msg "."<script> window.scrollTo({ left: 0, top: document.body.scrollHeight, behavior: 'smooth' }); </script>\n";
		}

		@fds = $s->has_exception(0);

		foreach my $fd (@fds) {
			$terminate = 1;
		}
	}

	print "</PRE>\n";

	kill(9, $pid);
	close($fd_event);

	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_view_monitor') {
	$filter = $query->param("filter");

	$host = $current_config_json->{SunBus}->{ManagmentPort}->{ip};
	$port = $current_config_json->{SunBus}->{ManagmentPort}->{port};
	$prefix = $current_config_json->{SunBus}->{SpyLinePrefix};

	if($host eq "0.0.0.0") { $host = "127.0.0.1"; }

	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_view_monitor_events') {

	$filter = $query->param("filter");
	if(length($filter) < 1) { $filter = '.*';}

	$| = 1;
	use IO::Select;
	use Socket;

	$host = $current_config_json->{SunBus}->{ManagmentPort}->{ip};
	$port = $current_config_json->{SunBus}->{ManagmentPort}->{port};
	$prefix = $current_config_json->{SunBus}->{SpyLinePrefix};

	if($host eq "0.0.0.0") { $host = "127.0.0.1"; }

#	header_simple();
	print_tpl ("header_simple");
	print "<pre>\n";


	my $fd_socket = \*SOCKET;
	my $fd_stdin = \*STDIN;

	socket($fd_socket, PF_INET,SOCK_STREAM,(getprotobyname('tcp'))[2]);

	if(!connect( $fd_socket, pack_sockaddr_in($port, inet_aton($host)))) {
		print "Ошибка соединения с системным монитором (host:$host, port:$port), проверьте правильность параметров в секции SunBus/ManagmentPort.\n";
		print_tpl ("footer");
		close($fd_socket);
		exit(0);
	}

	my $msg = "$prefix core TEXT:ReadyForJob\n";

	syswrite($fd_socket, $msg, length($msg));

	$s = IO::Select->new();
	$s->add($fd_stdin);
	$s->add($fd_socket);

	my $terminate = 0;

	while($terminate == 0) {

		@fds = $s->can_read(1);

		foreach my $fd (@fds) {

			if($fd == $fd_stdin) { $terminate = 1; next; }

			$msg = <$fd>;

			$msg =~ s/\</&lt;/g;
			$msg =~ s/\>/&gt;/g;

			chop($msg);

			if($msg =~ $filter) {

				my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime();
				my $ts = sprintf("%04d-%02d-%02d %02d:%02d:%02d", $year+1900, $mon+1, $mday, $hour, $min, $sec);

				my $style="gray";
				if($msg =~ /:AudioStreamer:/) { $style = "blue"; }
				elsif($msg =~ /:VideoStreamer:/) { $style = "green"; }
				elsif($msg =~ /:SuperGlue:/) { $style = "yellow"; }
				elsif($msg =~ /:SIP:/) { $style = "magenta"; }
				elsif($msg =~ /:GUI:/) { $style = "pink"; }

				$msg = "<span style=\"color:$style\">$msg</span>";

				print "$ts $msg "."<script> window.scrollTo({ left: 0, top: document.body.scrollHeight, behavior: 'smooth' }); </script>\n";
				#print time() . " $msg "."<script> window.scrollTo({ left: 0, top: document.body.scrollHeight}); </script>\n";
				#print time() . " $msg \n";
				#STDOUT->flush();
			}
		}

		@fds = $s->has_exception(0);

		foreach my $fd (@fds) {
			$terminate = 1;
		}
	}

	print "BYE\n";

	close($fd_socket);

	print_tpl ("footer");
	exit(0);

}


if($action eq 'system_view_modules_version') {

	print_tpl ("header");
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}

if($action eq 'system_upload_update') {

	print_tpl ("header");
	my $media_dir = $current_config_json->{HTTPRequester}->{media_dir};
	print_tpl ($action);
	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_upload_update_submit') {

	$file_handle = $query->upload("file");
	$file_name = $query->param("file");


	my $total_bytes = 0;
	my $media_dir = $current_config_json->{HTTPRequester}->{media_dir};
	my $store_file_name = $media_dir."/firmware_updates/".$file_name;

	print_tpl ("header");

	if(!open (OUTFILE, '>', $store_file_name)) {
		
		print "<script>alert(\"Невозможно сохранить файл $file_name. Ошибка: $!\")</script>\n";

		print_tpl ("footer");
		exit(0);
	}

	binmode STDIN;
	binmode OUTFILE;

	while ($bytesread = sysread($file_handle, $buffer, 1024)) {
		print OUTFILE $buffer;
		$total_bytes += $bytesread;
		##printf(STDERR "READ: $bytesread\n");
	}

	print "<script>alert(\"Файл $file_name загружен и сохранен в спуле для обновлений. Принято $total_bytes байт.\")</script>\n";
	print "<script>self.location='$prog?action=system_upload_update';</script>\n";

	print_tpl ("footer");
	exit(0);
}


if($action eq 'system_delete_update_file') {

	$name = $query->param("name");
	$name =~ s/\.\.\///g;

	my $media_dir = $current_config_json->{HTTPRequester}->{media_dir};
	my $file = $media_dir."/firmware_updates/".$name;

	print_tpl ("header");
	
	if(-f $file) {
		unlink $file;
		print "<script>alert(\"Файл $name удален!\");self.location=\"$prog?action=system_upload_update\";</script>\n";
	} else {
		print "<script>alert(\"Файл $name не найден!\");self.location=\"$prog?action=system_upload_update\";</script>\n";
	}

	print_tpl ("footer");
	exit(0);
}

sub save_config {
	$serial = time();
	$current_config_json->{Config}->{serial} = $serial;
	$current_config_json->{Config}->{source} = 'WebAdmin - '.$ENV{REMOTE_ADDR};

	$config_file = $ENV{X_CONFIG_SPOOL_DIR}. "/" . $ENV{X_CONFIG_FILE_NAME} . "." . $serial;
	$config_file_md5 = $config_file . ".md5";
	$config_file_symlink = $ENV{X_CONFIG_SPOOL_DIR}. "/" . $ENV{X_CONFIG_FILE_NAME};

	$data = $json_parser->utf8->encode($current_config_json);

	#write_file($config_file, {binmode => ':utf8'}, $data);
	return undef if(write_file($config_file, $data) == undef);

	$digest = md5_hex($data)."\n";

	return undef if(write_file($config_file_md5, {binmode => ':utf8'}, $digest) == undef);

	unlink($config_file_symlink);

	return symlink($config_file, $config_file_symlink);

	#print "<pre>\n";
	#print Dumper($current_config_json)."\n";
	#print "</pre>\n";
}

sub header_simple {

	print "Content-type: text/html; charset=utf-8\n\n";

	print "<head>\n";
	print "<meta charset=\"utf-8\" />\n";
	print "<meta http-equiv=\"cache-control\" content=\"no-cache\"/>\n";
	print "<meta http-equiv=\"pragma\" content=\"no-cache\"/>\n";
	print "</head>\n";
	print "<h1>OLD template</h1>";
}

sub header_simple_with_style {

	print "Content-type: text/html; charset=utf-8\n\n";

	print "<head>\n";
	print "<meta charset=\"utf-8\" />\n";
	print "<meta http-equiv=\"cache-control\" content=\"no-cache\"/>\n";
	print "<meta http-equiv=\"pragma\" content=\"no-cache\"/>\n";
	print "<link rel='stylesheet' id='theme_stylesheet' href='bootstrap-combined.min.css' -->\n";
	print "<link rel='stylesheet' id='icon_stylesheet' href='font-awesome.css'>\n";
	print "</head>\n";
	print "<h1>OLD template</h1>";
}



sub FindHwmonDevice {
	my $device_name = shift @_;
	my $i;
	
	for($i = 0; $i < 10; $i++) {
		my $tmp_str;
		$tmp_str = sprintf("/sys/class/hwmon/hwmon%d/name", $i);

		if(-f $tmp_str) {

			$name = read_file($tmp_str);
			chop $name;

			#printf(STDERR "Device name: %s\n", name);

			if($name eq $device_name) {
				return $tmp_str;
			}
		}
	}

	return "";
}


sub FindInputDevice {
	my $device_name = shift @_;
	my $i;
	
	for($i = 0; $i < 10; $i++) {
		my $tmp_str;
		$tmp_str = sprintf("/dev/input/event%d", $i);

		if(-e $tmp_str) {

			open(my $EVDEVNAME, "$evdevname $tmp_str|") or next;

			$name = <$EVDEVNAME>;
			chop $name;
			close($EVDEVNAME);

			if($name eq $device_name) {
				return $tmp_str;
			}
		}
	}

	return "";
}



print "Content-type: text/plain; charset=utf-8\n\n";

print "Error occured.\n\n";

print Dumper($query)."\n\n"; 

system("env");

exit(1);


sub print_tpl  {
	include_ ("$TEMPLATES/".shift.".html");
};
sub eval_ {
	my ($filename,$left_tag,$right_tag)=@_;
	open IN , $filename or die "Can't open $filename";
	my $s;
	while(<IN>) { $s.=$_; }
	my $delimeter="EOT" . rand 0xFFFFFFFF;
	$s=~s/$left_tag/\n$delimeter\n/g;
	$s=~s/$right_tag/\nprint << "$delimeter";\n/g;
	$s="print << \"$delimeter\";\n$s\n$delimeter\n";

	### debug
	#$tmp=`date '+%Y-%m-%d_%H_%M_%S'`;
	#chop $tmp;
	#$tmp="/tmp/template_$tmp";
	#open (LOG , "> $tmp") or die "Can't open debug log file";
	#print LOG $s;
	#close LOG;
	###

	eval $s;
    	die $@ if $@;
}
################################################
sub include_ {
	my ($filename)=@_;
	eval_ $filename,$left_tag,$right_tag ;
}
################################################
sub alarm_handler {
	print "\n";
	flush;
	alarm(10);
}
###############################################

